// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var gAccounts = {
  _manager: null,
  _type: null,
  _account: null,
  
  load: function()
  {
    var bundle = document.getElementById("gm-accounts-bundle");
    
    try {
      this._manager = Components.classes["@longfocus.com/gmanager/manager;1"].getService(Components.interfaces.nsIGmailManager);
      this._manager.load();
      
      this._type = window.arguments[0];
    } catch(e) {}
    
    if (window.arguments.length > 1)
    {
      var current = parseInt(window.arguments[1]);
      this._account = this._manager.getAccount(current);
      
      document.getElementById("gm-accounts-username").value = this._account.username;
      document.getElementById("gm-accounts-username").size = (this._account.username.length < 10) ? 10 : this._account.username.length;
    }
    
    switch (this._type)
    {
      case "add":
        document.getElementById("gm-accounts-info").value = bundle.getString("accounts-add");
        document.getElementById("gm-accounts-username").value = "";
        document.getElementById("gm-accounts-username").select();
        document.getElementById("gm-accounts-password").hidden = false;
        document.getElementById("gm-accounts-remem").hidden = false;
        document.getElementById("gm-accounts-log-in").hidden = false;
        break;
      case "remove":
        document.getElementById("gm-accounts-info").value = bundle.getString("accounts-remove");
        document.getElementById("gm-accounts-username").disabled = true;
        document.getElementById("gm-accounts-log-in").checked = false;
        break;
      case "pass":
        document.getElementById("gm-accounts-info").value = bundle.getString("accounts-login");
        document.getElementById("gm-accounts-username").disabled = true;
        document.getElementById("gm-accounts-password").hidden = false;
        document.getElementById("gm-accounts-password-textbox").disabled = false;
        document.getElementById("gm-accounts-password-textbox").select();
        document.getElementById("gm-accounts-remem").hidden = false;
        break;
    };
  },
  
  validate: function()
  {
    document.getElementById("gm-accounts-password-textbox").disabled =
      (document.getElementById("gm-accounts-username").value == "");
    
    document.getElementById("gm-accounts-remem").disabled =
      (document.getElementById("gm-accounts-password-textbox").value == "");
  },
  
  accept: function()
  {
    var username = document.getElementById("gm-accounts-username").value;
    var password = document.getElementById("gm-accounts-password-textbox").value;
    var remem = document.getElementById("gm-accounts-remem").checked;
    var success = true;
    
    switch (this._type)
    {
      case "add":
        // Removes any email suffixes
        var atIndex = username.indexOf("@");
        
        if (atIndex > -1)
          username = username.slice(0, atIndex);
        
        success = this._manager.addAccount(username, password, remem);
        break;
      case "remove":
        this._manager.removeAccount(username);
        break;
      case "pass":
        this._manager.savePassword(username, password, remem);
        break;
    };
    
    // Close window
    self.close();
    
    if (success)
    {
      var observer = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
      observer.notifyObservers(null, "prefs-account-change", this._type);
      
      if (document.getElementById("gm-accounts-log-in").checked)
        observer.notifyObservers(null, "account-login", username);
    }
  }
}