// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var gImports = {
  _bundle: null,
  _manager: null,
  _iAccounts: new Array(),
  _visible: false,
  _overlay: null,
  
  load: function()
  {
    this._bundle = document.getElementById("gm-imports-bundle");
    this._overlay = window.arguments[0];
    
    try {
      this._manager = Components.classes["@longfocus.com/gmanager/manager;1"].getService(Components.interfaces.nsIGmailManager);
      this._manager.load();
    } catch(e) {}
    
    var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
    var passEnum = passManager.enumerator;
    var parent = document.getElementById("gm-imports-list");
    
    while (passEnum.hasMoreElements()) {
      var nextPass = passEnum.getNext().QueryInterface(Components.interfaces.nsIPassword);
      
      if (nextPass.host == "chrome://gm-notifier/") {
        var iAccount = new Object();
        iAccount.user = nextPass.user;
        iAccount.password = nextPass.password;
        iAccount.checked = true;
        
        this._iAccounts[iAccount.user] = iAccount;
        
        var listItem = this._createListItem(nextPass.user, nextPass.password);
        parent.appendChild(listItem);
      }
    }
    
    if (!parent.hasChildNodes())
      window.close();
  },
  
  _createListItem: function(aUsername, aPassword, aIndex)
  {
    var listItem = document.createElement("listitem");
    listItem.setAttribute("allowevents", "true");
    
    var listCell = document.createElement("listcell");
    var checkBox = document.createElement("checkbox");
    
    checkBox.setAttribute("label", aUsername);
    checkBox.setAttribute("checked", true);
    checkBox.setAttribute("oncommand", "gImports._markChecked(this);");
    listCell.appendChild(checkBox);
    listItem.appendChild(listCell);
    
    var listCell = document.createElement("listcell");
    var label = document.createElement("label");
    
    label.setAttribute("id", aPassword);
    label.setAttribute("value", aPassword);
    label.setAttribute("hidden", true);
    listCell.appendChild(label);
    listItem.appendChild(listCell);
    
    return listItem;
  },
  
  _markChecked: function(aCheckbox)
  {
    this._iAccounts[aCheckbox.label].checked = aCheckbox.checked;
  },
  
  _showPasswords: function()
  {
    this._visible = !this._visible;
    
    for (var iAccount in this._iAccounts) {
      var password = this._iAccounts[iAccount].password;
      var e = document.getElementById(password);
      e.hidden = !e.hidden;
    }
    
    var e = document.getElementById("gm-imports-show-passwords");
    e.label = (this._visible ? this._bundle.getString("imports-hide-passwords") : this._bundle.getString("imports-show-passwords"));
  },
  
  accept: function()
  {
    for (var iAccount in this._iAccounts) {
      if (this._iAccounts[iAccount].checked) {
        var username = this._iAccounts[iAccount].user;
        var password = this._iAccounts[iAccount].password;
        this._manager.addAccount(username, password, true);
      }
    }
    
    if (document.getElementById("gm-imports-login").checked)
      this._overlay.select("gm-overlay-menuitem-loginall");
    
    window.close();
  }
}