// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var gOverlayPopup = {
  populate: function(aId)
  {
    var bundle = document.getElementById("gm-overlay-bundle");
    var popup = document.getElementById(aId);
    var numAccounts = gOverlay._manager.getNumAccounts();
    var item = null;
    
    while (popup.hasChildNodes())
      popup.removeChild(popup.lastChild);
    
    if (numAccounts > 0) {
      if (numAccounts > 1) {
        var numLoggedIn = 0;
        
        for (var i = 0; i < numAccounts; i++) {
          var account = gOverlay._manager.getAccount(i);
          if (account.loggedIn) numLoggedIn++;
        }
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-loginall");
        item.setAttribute("label", bundle.getString("tb-popup-all-login"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        item.setAttribute("disabled", (numLoggedIn == numAccounts));
        popup.appendChild(item);
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-logoutall");
        item.setAttribute("label", bundle.getString("tb-popup-all-logout"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        item.setAttribute("disabled", (numLoggedIn == 0));
        popup.appendChild(item);
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-all-checknow");
        item.setAttribute("label", bundle.getString("tb-popup-all-check"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        item.setAttribute("disabled", (numLoggedIn == 0));
        popup.appendChild(item);
        
        popup.appendChild(document.createElement("menuseparator"));
      }
      
      if (gOverlay._current > -1) {
        var account = gOverlay._manager.getAccount(gOverlay._current);
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-loginout");
        item.setAttribute("label", account.loggedIn ? bundle.getString("tb-popup-selected-logout") : 
									bundle.getString("tb-popup-selected-login"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        popup.appendChild(item);
        
        if (account.loggedIn) {
          item = document.createElement("menuitem");
          item.setAttribute("id", "gm-overlay-menuitem-checknow");
          item.setAttribute("label", bundle.getString("tb-popup-selected-check"));
          item.setAttribute("oncommand", "gOverlay.select(this.id);");
          popup.appendChild(item);
          
          // Allows for snippets if the alerts-service is available
          if ("@mozilla.org/alerts-service;1" in Components.classes) {
            item = document.createElement("menuitem");
            item.setAttribute("id", "gm-overlay-menuitem-showsnippets");
            item.setAttribute("label", bundle.getString("tb-popup-selected-snippets"));
            item.setAttribute("oncommand", "gOverlay.select(this.id);");
            item.setAttribute("disabled", (account.inboxUnread == 0));
            popup.appendChild(item);
          }
        }
        
        popup.appendChild(document.createElement("menuseparator"));
      }
      
      for (var i = 0; i < numAccounts; i++) {
        var account = gOverlay._manager.getAccount(i);
        var unread = gOverlay._getUnread(account);
        var checked = (gOverlay._current == i);
        
        // Account menu item
        item = document.createElement("menuitem");
        item.setAttribute("class", "gm-menuitem");
        item.setAttribute("type", "radio");
        item.setAttribute("checked", checked);
        item.setAttribute("default", checked);
        item.setAttribute("username", account.username);
        item.setAttribute("unread", unread);
        item.setAttribute("status", account.status);
        item.setAttribute("newMail", unread > 0);
        item.setAttribute("iconsize", "small");
        item.setAttribute("value", i);
        item.setAttribute("oncommand", "gOverlay.selectAccount(this.value, true);");
        
        popup.appendChild(item);
      }
    }
    else {
      item = document.createElement("menuitem");
      item.setAttribute("label", bundle.getString("tb-popup-add-account"));
      item.setAttribute("oncommand", "window.openDialog('chrome://gmanager/content/accounts.xul', 'accounts', 'chrome, dependent=yes', 'add');");
      popup.appendChild(item);
    }
    
    popup.appendChild(document.createElement("menuseparator"));
    
    item = document.createElement("menuitem");
    item.setAttribute("label", bundle.getString("tb-popup-homepage"));
    item.setAttribute("accesskey", bundle.getString("tb-popup-homepage.ak"));
    item.setAttribute("oncommand", "visitSite(GMANAGER_WEBSITE);");
    popup.appendChild(item);
    
    item = document.createElement("menuitem");
    item.setAttribute("label", bundle.getString("tb-popup-prefs"));
    item.setAttribute("accesskey", bundle.getString("tb-popup-prefs.ak"));
    item.setAttribute("default", "true");
    item.setAttribute("oncommand", "window.openDialog('chrome://gmanager/content/preferences.xul', 'prefs', 'chrome,dependent=yes');");
    popup.appendChild(item);
  }
}